<?php

namespace STM\User;

use \Exception;
use STM\StmFactory;

/**
 * Test class for UserValidator.
 * Generated by PHPUnit on 2011-08-29 at 18:02:19.
 * @group user
 */
class UserValidatorTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $all_users;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());
        $this->all_users = StmFactory::find()->User->findAll();
    }
    protected function tearDown() {}

    public function testCheck_create() {
        foreach ($this->bad_values as $value) {
            UserValidator::init();            
            $this->assertFalse(UserValidator::checkCreate($value));
            UserValidator::init();
            $this->assertFalse(UserValidator::checkCreate(array($value)));
        }        
    }

    public function testCheck_user_group() {
        foreach ($this->bad_values as $value) {
            UserValidator::init();
            $this->assertFalse(UserValidator::checkUserGroup($value));
        } 
        
        foreach ($this->all_users as $user) {
            UserValidator::init();
            UserValidator::setUser($user);
            $this->assertFalse(UserValidator::checkUserGroup(UserGroup::getIdGroup($user->getUserGroup())));
            UserValidator::resetUser();
        }
        
        UserValidator::init();
        $valid = array('A', 'M', 'C', 'R');
        foreach ($valid as $value) {            
            $this->assertTrue(UserValidator::checkUserGroup($value));
        } 
    }

    public function testCheck_name() {
        foreach ($this->bad_values as $value) {
            UserValidator::init();
            $this->assertFalse(UserValidator::checkName($value));
        } 
        
        foreach ($this->all_users as $user) {
            // fail on exists team
            UserValidator::init();            
            $this->assertFalse(UserValidator::checkName(mb_strtolower($user->getUsername(), 'UTF-8')));
            UserValidator::init();
            $this->assertFalse(UserValidator::checkName(mb_strtoupper($user->getUsername(), 'UTF-8')));
            
            // fail on comparing with current name
            UserValidator::init();
            UserValidator::setUser($user);
            $this->assertFalse(UserValidator::checkName($user->getUsername()));
            UserValidator::resetUser();
        }

        // invalid size
        $invalid = array('', 'A', '1234567890123456789012345678901');
        foreach ($invalid as $value) {            
            UserValidator::init();
            $this->assertFalse(UserValidator::checkName($value));
        } 
    }

    public function testCheck_passsword() {
        // only check string and size 5 - 50
        
        foreach ($this->bad_values as $value) {
            UserValidator::init();
            $this->assertFalse(UserValidator::checkPasssword($value));
        } 
        
        $invalid = array('', 'A', '12', '123', '1234', '1234567890123456789012345678901234567890123456789012345');
        foreach ($invalid as $value) {            
            UserValidator::init();
            $this->assertFalse(UserValidator::checkPasssword($value));
        }         
    }

    public function testCheck_new_passsword() {
        // not set user -> fail
        UserValidator::init();
        $this->assertFalse(UserValidator::checkNewPassword(array('new' => 5656, 'old' => 'dasdsa')));
        
        foreach ($this->all_users as $user) {            
            foreach ($this->bad_values as $value) {
                // argument must be array('new' => ...., 'old' => ...)
                UserValidator::init();
                UserValidator::setUser($user);                                
                $this->assertFalse(UserValidator::checkNewPassword($value));
                
                // old,new must be string 5-50 (test in testcheckPasssword)
                UserValidator::init();
                $this->assertFalse(UserValidator::checkNewPassword(array('new' => $value, 'old' => $value)));
                
                // old and new must be different strings
                UserValidator::init();
                $this->assertFalse(UserValidator::checkNewPassword(array('new' => 'similar', 'old' => 'similar')));
                
                // other error if 'old' is different from current password - cannot check this
                
                UserValidator::resetUser();
            } 
            
        }
    }

    public function testCheck_email() {
        // only string
        foreach ($this->bad_values as $value) {
            UserValidator::init();
            $this->assertFalse(UserValidator::checkEmail($value));
        } 
        
        // size - <4, 60> + invalid emails
        $invalid = array('', 'A', '12', '123', '12345678901234567890123456789012345678901234567890123456789012', 'test@test', '@test.cz');
        foreach ($invalid as $value) {            
            UserValidator::init();
            $this->assertFalse(UserValidator::checkEmail($value));
        }         
        
        // different from current email
        foreach ($this->all_users as $user) {
            UserValidator::init();
            UserValidator::setUser($user);            
            $this->assertFalse(UserValidator::checkEmail($user->getEmail()));
            UserValidator::resetUser();
        }
        
        // valid emails
        UserValidator::init();
        $valid = array('bob@example.com', 'dsa@fojasd.cn');
        foreach ($valid as $value) {            
            $this->assertTrue(UserValidator::checkEmail($value));
        } 
    }

}

?>
